import java.awt.*;
import java.awt.event.*;

public class MenuTest extends Frame
                      implements MouseListener, ActionListener
{

   MenuItem j, megnyit, kilp;
   PopupMenu munkalapok;

   public static void main(String args[]) {
      MenuTest g=new MenuTest("Men Teszt");
      g.show();
   }

   MenuTest(String s) {
      super(s);
      MenuBar mb=new MenuBar();                  //MenuBar ltrehozsa

         Menu fjl=new Menu("Fjl");             //Menu ltrehozsa
            j=new MenuItem("j");               //MenuItem ltrehozsa
            j.addActionListener(this);          //parancs hozzrendelse
            fjl.add(j);
            megnyit=new MenuItem("Megnyit");
            megnyit.addActionListener(this);
            fjl.add(megnyit);
            MenuItem lezr=new MenuItem("Lezr");
            lezr.setEnabled(false);             //menpont letiltsa
            lezr.addActionListener(this);
            fjl.add(lezr);
            fjl.addSeparator();                 //elvlaszt vonal
            kilp=new MenuItem("Kilps");
            kilp.addActionListener(this);
            fjl.add(kilp);
         mb.add(fjl);                           //Menu csatolsa MenuBar-hoz
         Menu keress=new Menu("Keress");
            Menu keres=new Menu("Keres");
               MenuItem norml=new MenuItem("Norml");
               norml.addActionListener(this);
               keres.add(norml);
            keress.add(keres);                  //almen csatolsa
            MenuItem cserl=new MenuItem("Cserl");
            cserl.addActionListener(this);
            keress.add(cserl);
         mb.add(keress);
         Menu kperny=new Menu("Kperny");
            MenuItem marg=new MenuItem("Margk");
            marg.addActionListener(this);
            kperny.add(marg);
            MenuItem sortrs=new MenuItem("Sortrs");
            sortrs.addActionListener(this);
            kperny.add(sortrs);
            CheckboxMenuItem ra=new CheckboxMenuItem("ra");     //kapcsol
            ra.addActionListener(this);
            kperny.add(ra);
         mb.add(kperny);
         Menu segt=new Menu("segt");
         segt.addActionListener(this);
         mb.setHelpMenu(segt);
      setMenuBar(mb);
      munkalapok=new PopupMenu("Munkalapok");//PopupMenu ltrehozsa
         MenuItem lap1=new MenuItem("1");
         lap1.addActionListener(this);
         munkalapok.add(lap1);
         MenuItem lap2=new MenuItem("2");
         lap2.addActionListener(this);
         munkalapok.add(lap2);
      add(munkalapok);              //PopupMenu kapcsolsa a Frame-hez
      addMouseListener(this);            //egrfigyels a PopupMenu-hz
      setSize(400, 200);
      setResizable(false);
      validate();
   }
   //MouseListener interfsz implementlsa
   public void mouseClicked(MouseEvent e) {}
   public void mouseEntered(MouseEvent e) {}
   public void mouseExited(MouseEvent e) {}
   public void mouseReleased(MouseEvent e) {}
   public void mousePressed(MouseEvent e) {
      if (e.isPopupTrigger()) {
         munkalapok.show(this, e.getX(), e.getY());//PopupMenu megjelentse
      }
   }
   //ActionListener interfsz implementlsa a parancsok lekezelshez
   public void actionPerformed(ActionEvent ae) {
      Object s=ae.getSource();
      if (s.equals(j)) {
         System.out.println("j fjl megnyitsa.");
      }
      else if (s.equals(megnyit)) {
         System.out.println("Ltez fjl megnyitsa.");
      }
      else if (s.equals(kilp)) {
         System.exit(0);
      }
      else {
         System.out.println("*** "+ae+" ***");
      }
   }
}
