import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.util.Enumeration;
import java.util.Vector;

class StringsDialog extends Frame implements ActionListener {    //dialgusdoboz
  TextArea textArea=new TextArea();                                 //szvegmez

  public StringsDialog() {
    super("Inf");                                      //felletnek felptse
    Button b=new Button("ok");
    b.addActionListener(this);
    add("South", b);
    add("Center", textArea);
    textArea.setEditable(false);
    setSize(300,200);
    validate();
  }
  public void actionPerformed(ActionEvent e) {           //gombnyoms lekezelse
       dispose();                                            //dialgus bezrsa
  }
}
public class GetAppletTest extends Applet implements ActionListener {
  static StringsDialog stringsDialog=new StringsDialog();
  static int counter;                                          //pldnyszmll
  int ID;                                                        //pldny szma
  private Vector appletv=new Vector();                    //aktulis appletlista
  TextField paramTextField=new TextField();                     //fellet elemei
  Panel buttonPanel=new Panel();
  Button infoButton=new Button("AppletInfo ");
  Button paramInfoButton=new Button("ParameterInfo ");
  Button getParamButton=new Button("Parameter");
  List appletList=new List(10, false);

  public GetAppletTest() {
    ID=++counter;                                         //pldny megszmozsa
    paramTextField.setText("Ez a(z) "+ID+". pldny");      //fellet felptse
    infoButton.addActionListener(this);
    paramInfoButton.addActionListener(this);
    getParamButton.addActionListener(this);
    buttonPanel.add(infoButton);
    buttonPanel.add(paramInfoButton);
    buttonPanel.add(getParamButton);
    setLayout(new BorderLayout());
    add("North", paramTextField);
    add("Center", appletList);
    add("South", buttonPanel);
    validate();
  }
  public String getAppletInfo() {
    return "Ez a GetAppletTest osztly "+ID+". pldnya.\n"+
           "Ezen applet az egy HTML lapon tallhat appletek "+
           "kommunikcis lehetsgt illusztrlja.";
  }
  public void start() {
    Applet applet;
    String s;

    Enumeration applets=getAppletContext().getApplets();     //elrhet appletek
    appletList.removeAll();                                //appletlista trlse
    appletv.removeAllElements();
    while (applets.hasMoreElements()) {                 //appletlista felptse
          applet=(Applet)applets.nextElement();
          if (applet==null) continue;
          appletv.addElement(applet);
          if ((s=applet.getParameter("name"))==null) s="";
          if (applet instanceof GetAppletTest) s=s+"(GetAppletTest "+
             ((GetAppletTest)applet).ID+")";
          else s=s+"("+applet.toString()+")";
          if (applet==this) s=">"+s;                        //nmaga megjellse
          appletList.addItem(s);
          if (applet==this)                        //nmaga kezdeti kivlasztsa
             appletList.select(appletList.getItemCount()-1);
    }
    validate();
  }
  private Applet getAct(String title) {        //kivlasztott Applet visszaadsa
    Applet result=null;
    int index;
    String name;
    Applet getByName;

    stringsDialog.textArea.setText("");
    if ((index=appletList.getSelectedIndex())!=-1) {           //van kivlasztva
       result=(Applet)appletv.elementAt(index);
       if ((name=result.getParameter("name"))!=null) {                //van neve
          if ((getByName=getAppletContext().getApplet(name))!=null) {
             stringsDialog.textArea.append(               //nv szerint elrhet
                          "getApplet("+name+")="+getByName+"\n");
             result=getByName;
          } else stringsDialog.textArea.append("getApplet("+
                 name+") null-t adott vissza!\n");
       } else stringsDialog.textArea.append("Az appletnek nincs neve\n");
       stringsDialog.setTitle(result+".get"+title+"() eredmnye");
       stringsDialog.textArea.append("------------------------\n");
    }
    return result;
  }
  public void actionPerformed(ActionEvent e) {
    if (e.getSource()==infoButton)                     //getAppletInfo meghvsa
       stringsDialog.textArea.append(getAct("AppletInfo ").getAppletInfo());
    else if (e.getSource()==paramInfoButton) {      //getParameterInfo meghvsa
         String[][] params=getAct("ParameterInfo ").getParameterInfo();
         if (params!=null) for (int i=0; i<params.length; i++) {
            for (int j=0; j<params[i].length; j++)
                stringsDialog.textArea.append(params[i][j]+" ");
            stringsDialog.textArea.append("\n");
         } else stringsDialog.textArea.append("Nincsenek paramterek\n");
    } else if (e.getSource()==getParamButton)                     //getParameter
           stringsDialog.textArea.append(paramTextField.getText()+"="+
                    getAct("Parameter").getParameter(paramTextField.getText()));
    stringsDialog.show();
    start();
  }
}
