import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;

public class SecurityTest extends Applet implements ActionListener {
  Panel buttonPanel=new Panel();                                //fellet elemei
  Button suspendButton=new Button("resume");
  Button exitButton=new Button("exit");
  Button clearButton=new Button("clear");
  Button propertiesButton=new Button("properties");
  Button execButton=new Button("exec");
  Button socketButton=new Button("socket");
  Button readButton=new Button("read");
  Button writeButton=new Button("write");
  Button deleteButton=new Button("delete");
  Button protocolButton=new Button("protocoll");
  TextArea textArea=new TextArea();

  public SecurityTest() {
    buttonPanel.setLayout(new GridLayout(0, 1));            //fellet felptse
    suspendButton.addActionListener(this);
    propertiesButton.addActionListener(this);
    protocolButton.addActionListener(this);
    readButton.addActionListener(this);
    writeButton.addActionListener(this);
    deleteButton.addActionListener(this);
    execButton.addActionListener(this);
    socketButton.addActionListener(this);
    clearButton.addActionListener(this);
    exitButton.addActionListener(this);
    buttonPanel.add(suspendButton);
    buttonPanel.add(propertiesButton);
    buttonPanel.add(protocolButton);
    buttonPanel.add(readButton); buttonPanel.add(writeButton);
    buttonPanel.add(deleteButton);
    buttonPanel.add(execButton);
    buttonPanel.add(socketButton);
    buttonPanel.add(clearButton);
    buttonPanel.add(exitButton);
    textArea.setEditable(false);
    setLayout(new BorderLayout());
    add("West", buttonPanel); add("Center", textArea);
    validate();
  }
  public String getAppletInfo() {                              //programrl inf
    return "Ez az alkalmazs/applet a biztonsgi megszortsokat szemllteti.";
  }
  public static void main(String args[]) {              //indts alkalmazsknt
    SecurityTest mySecurityTest=new SecurityTest();              //pldnyosts
    Frame myFrame=new Frame("SecurityTest alkalmazs");     //fellet felptse
    myFrame.add("Center", mySecurityTest);
    myFrame.setSize(600,200);
    myFrame.show();
  }
  public void actionPerformed(ActionEvent e) {           //gombnyoms lekezelse
   try {
    if (e.getSource()==clearButton) {                                    //clear
       textArea.setText("");
       return;
    } else if (e.getSource()==exitButton) {                               //exit
         textArea.append("System.exit(0): ");
         System.exit(0);
    } else if (e.getSource()==suspendButton) {                          //resume
           ThreadGroup threadGroup=Thread.currentThread().getThreadGroup();
           textArea.append("resume "+threadGroup+": ");
           threadGroup.resume();
    } else if (e.getSource()==propertiesButton) {                   //properties
           textArea.append("System.getProperties(): ");
           System.getProperties();
    } else if (e.getSource()==execButton) {                               //exec
           textArea.append("Runtime.getRuntime().exec("+
               '"'+"/usr/bin/rm SecurityTest.test"+'"'+"): ");
           Runtime.getRuntime().exec("/usr/bin/rm SecurityTest.test");
    } else if (e.getSource()==socketButton) {                           //socket
           textArea.append("Echo server(socket 7) java.inf.elte.hu teszt: ");
           Socket socket=new Socket("java.inf.elte.hu", 7);
           BufferedReader in=new BufferedReader(
                             new InputStreamReader(socket.getInputStream()));
           PrintWriter out=new PrintWriter(socket.getOutputStream());
           out.println("O.K."); out.flush();
           textArea.append(in.readLine());
           in.close();
           out.close();
           socket.close();
    } else if (e.getSource()==readButton) {                               //read
           textArea.append("Read SecurityTest.test: ");
           FileInputStream in=new FileInputStream(
                              new File("SecurityTest.test"));
           in.read();
           in.close();
    } else if (e.getSource()==writeButton) {                             //write
           textArea.append("Write SecurityTest.test: ");
           FileOutputStream out=new FileOutputStream(
                                new File("SecurityTest.test"));
           out.write(0);
           out.close();
    } else if (e.getSource()==deleteButton) {                           //delete
           textArea.append("Delete SecurityTest.test: ");
           new File("SecurityTest.test").delete();
    } else if (e.getSource()==protocolButton) {                      //protokoll
           textArea.append("getAudioClip(getCodeBase(), "+
                               '"'+"../clip.au "+'"'+"): ");
           getAudioClip(getCodeBase(), "../clip.au ");
    }
    textArea.append("O.K.\n");                                        //sikerlt
   } catch (Exception ex) {textArea.append(ex+"\n");}                     //hiba
  }
}
