public abstract class Sikidom {
    public abstract double kerulet();
    public abstract double terulet();
}

class Kor extends Sikidom {
    public double r;

    public double kerulet() {
        return 2*Math.PI*r;
    }

    public double terulet() {
        return r*r*Math.PI;
    }
}

class Teglalap extends Sikidom {
    public double a, b;

    public double kerulet() {
        return 2*a*b;
    }
    public double terulet() {
        return a*b;
    }
}
