import java.util.*;

class Nebantsvirag extends Observable {
  public void vltozik(Object o) {
    setChanged();
    notifyObservers(o);
  }
}

class Szamlalo implements Observer {
  int vltozsok;

  public void update(Observable o, Object obj) {
    vltozsok++;
  }
  public int vltozsokSzma() {
    return vltozsok;
  }
}

class Spion implements Observer {
  public void update(Observable o, Object obj) {
    System.out.println("Ne bntstok szegnyt! Te meg '"+obj+"', menj vissza!");
  }
}

class VizsgalApp {
  public static void main(String argv[]) {
    Nebantsvirag n=new Nebantsvirag();
    Szamlalo s=new Szamlalo();
    Spion fika=new Spion();
    
    n.addObserver(s);
    n.addObserver(fika);
    n.vltozik(new Integer(100));
    n.vltozik("piszka, motoszka");

    System.out.println("A Nebntsvirgot " + s.vltozsokSzma()+
		       "-szer vltoztattk.");
  }
}
