import java.awt.*;
import java.awt.event.*;
import java.applet.*;

public class SzinSzabalyzo extends Applet {
  Minta m=new Minta();
  Scrollbar barVilagossag=new Scrollbar(Scrollbar.HORIZONTAL, 0, 30, 0, 255),
  barSzin=new Scrollbar(Scrollbar.HORIZONTAL, 0, 30, 0, 255),
  barTelitettseg=new Scrollbar(Scrollbar.HORIZONTAL, 0, 30, 0, 255);
  /* tmretez metdus */
  private void meretezes(Component c, int x, int y, int w, int h) {
    c.setSize(w*30, h*30);
    c.setLocation(x*30, y*30);
  }
  public void init() {
    add(barVilagossag);
    add(barSzin);
    add(barTelitettseg);                     //scrollbar-ok beraksa az appletbe
    add(m);                                           //sznes tglalap beraksa
    m.regisztralas(barVilagossag, barSzin, barTelitettseg);  //sc.bar-ok tadsa
    barVilagossag.addAdjustmentListener(m);
    barSzin.addAdjustmentListener(m);
    barTelitettseg.addAdjustmentListener(m);           //m lesz az esemnykezel
  }
  public void paint(Graphics g) {       //kirajzolskor a komponensek mretezse
    meretezes(m, 0, 0, 5, 5);
    meretezes(barVilagossag, 5, 0, 5, 1);
    meretezes(barSzin, 5, 1, 5, 1);
    meretezes(barTelitettseg, 5, 2, 5, 1);
  }
}

class Minta extends Canvas implements AdjustmentListener {
  float v=0, s=0, t=0;                //vilgossg, szn, teltettsg trolsra
  Adjustable av, as, at;    //a hrom grgetsv trolsra, megklnbztetshez

  public void regisztralas(Adjustable pv,Adjustable ps,Adjustable pt) {
    av=pv;as=ps;at=pt;
  }
  public void adjustmentValueChanged(AdjustmentEvent e) {         //szablyozsi
    if(e.getAdjustable()==av) v=e.getValue();               //esemny lekezelse
    else if(e.getAdjustable()==as) s=e.getValue();    // elgazunk attl fggen
    else if(e.getAdjustable()==at) t=e.getValue();  //hogy ki kldte az esemnyt
    paint(getGraphics());                  //ngyzet jrarajzoltatsa j sznnel
  }
  public void paint(Graphics g) {       //megfelel szn kiszmtsa s rajzols
    g.setColor(new Color(Color.HSBtoRGB(s/255, t/255, v/255)));
    g.fillRect(0, 0, getSize().width, getSize().height);
  }
}
