//                                                                 //
//                 Kliens-szerver Demo, 1997.                      //
//                                                                 //
//         Ksztette: Fodor Szabina s Gulys Lszl              //
//                                                                 //
//                                                                 //
//    Egyszer applet, mely a kliens felhasznli felletnek      //
//    alapjait valstja meg.                                      //
//                                                                 //

//    Az alkalmazs kliens oldala
import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;

//     Az 'adatbzis'-kliens applet osztlya (felhasznli fellet)
public class Client extends Applet implements ActionListener {

//  Vltozk definilsa
    // Szvegmezk
    private TextField nameField;  // A felhasznli nv beviteli mezje
    private TextField passField;  // A jelsz beviteli mezje
    private TextArea  infoField;  // A kliens tjkoztat mezje

    // Cimkk
    private Label     nameLabel;  // A nv cimkjje
    private Label     passLabel;  // A jelsz cimkje 
    private Label     infoLabel;  // A tjkoztatmez cimkje 
    
    // Nyomgombok
    private Button    logButton;  // A Ki/Bejelentkezs gombja

//  A felhasznli felletel kapcsolatos metdusok    
  // Az applet indtsa
    public void init()  {
        // A pakolsi stratgia ltrehozsa s belltsa
        GridBagLayout      gridbag     = new GridBagLayout();
        GridBagConstraints constraints = new GridBagConstraints();
        setFont(new Font("TimesRoman", Font.BOLD, 14));
        setLayout(gridbag);
        constraints.anchor  = GridBagConstraints.WEST;
        constraints.weighty = 0.0;

        // 'nv' cimke s szvegmez elksztse
        nameLabel = new Label("Nv : ", Label.LEFT);
        nameField = new TextField(20);
        constraints.gridwidth = 1;
        addFormComponent(gridbag, nameLabel, constraints);
        constraints.gridwidth = GridBagConstraints.REMAINDER;
        constraints.fill      = GridBagConstraints.HORIZONTAL;
        addFormComponent(gridbag, nameField, constraints);
 
        // 'jelsz' cimke s szvegmez elksztse
        passLabel = new Label("Jelsz : ", Label.LEFT);
        passField = new TextField(20);
        passField.setEchoChar('#');
        constraints.gridwidth = 1;
        constraints.fill      = GridBagConstraints.NONE;
        constraints.weightx   = 0.0;
        addFormComponent(gridbag, passLabel, constraints);
        constraints.gridwidth = GridBagConstraints.REMAINDER;
        constraints.weightx   = 1.0;
        addFormComponent(gridbag, passField, constraints);
 
        // 'zenetek' szvegmez elhelyezse
        infoLabel = new Label("zenetek:", Label.LEFT);
        infoField = new TextArea(5,40);
        infoField.setEditable(false);
        constraints.gridwidth = 1;
        constraints.weightx   = 0.0;
        constraints.weighty   = 0.1;
        constraints.fill      = GridBagConstraints.NONE;
        addFormComponent(gridbag, infoLabel, constraints);
        constraints.fill      = GridBagConstraints.HORIZONTAL;
        constraints.gridwidth = GridBagConstraints.REMAINDER;
        constraints.weightx   = 1.0;
        addFormComponent(gridbag, infoField, constraints);
 
        // A 'Bejelentkezs' gomb elksztse
        logButton = new Button("BEJELENTKEZS");
        logButton.addActionListener(this);
        constraints.weightx   = 1.0;
        constraints.weighty   = 0.5;
        constraints.fill      = GridBagConstraints.BOTH;
        constraints.gridheight= GridBagConstraints.REMAINDER;        
        constraints.gridx     = 1;
        constraints.gridwidth = GridBagConstraints.REMAINDER;     
        addFormComponent(gridbag, logButton, constraints);
        resize(500, 350);    
    }

  // Segdeljrs a komponensek kpernyre helyezshez   
    private void addFormComponent( GridBagLayout grid, Component comp, 
                                   GridBagConstraints c )  {
        grid.setConstraints(comp, c);
        add(comp);
    }

  // Informci az appletrl
    public String getAppletInfo() {
       return "Az egyszer kliens-szerver demo kliens appletjnek fellete.";
    }
  // Informci az applet paramtereirl
    public String[][] getParameterInfo() { return null; }
  // Esemnyek kezelse
    public void actionPerformed(ActionEvent event)  {
          // Melyik gomb volt? A megfelel kezeleljrs hvsa
          if (event.getSource() == logButton)  {
              infoField.append("A gombot lenyomtk.\n");
          } 
    }
}
