class MyThread extends Thread {
  public void run() {
    System.out.println( "Indul a " + getName() + " Thread" );
    for (int i=0; i<5; i++) {
      try { sleep(500); } catch (InterruptedException e) {}
      System.out.println( "Hell, ez itt a " + getName() + " Thread");
    }
    System.out.println( getName() + " Thread vge" );
  }
}
 
class MyThread2 extends Thread {
  private Thread wait4me;
 
  MyThread2(Thread target) {
    super();
    wait4me = target;
  }
  public void run() {
    System.out.println( getName() + " Thread megvrja " +
                        wait4me.getName() + " Thread-et");
    try { wait4me.join(); } catch (InterruptedException e) {}
    for (int i=0; i<5; i++) {
      try { sleep(500); } catch (InterruptedException e) {}
      System.out.println( "Hell, ez itt a " + getName() + " Thread");
    }
  }
}
 
public class JoinTest {
  static public void main(String args[]) {
    MyThread a;
    MyThread2 b;
 
    a = new MyThread();
    b = new MyThread2( a );
    a.start();
    b.start();
  }
}
